#include <pspsdk.h>
#include <pspkernel.h>
#include <string.h>
#include <psppower.h>


PSP_MODULE_INFO("1337acscwyacyp", 0x1000, 1, 0);
PSP_MAIN_THREAD_ATTR(0);


#define DELAY_TIME		100000
#define	DISPLAY_TIME	40

int click = 0;


void setCPU(int cpuSpeed)
{
	scePowerSetClockFrequency(cpuSpeed, cpuSpeed, cpuSpeed/2);
}

int main_thread(SceSize args, void *argp)
{
	for (;;)
	{
		if (scePowerIsBatteryCharging())
		{
			if (scePowerGetCpuClockFrequency() != 333)
			{
				click = 1;
				setCPU(333);
			}
		}
		else
		{
			if (scePowerGetCpuClockFrequency() != 222)
			{
				click = 0;
				setCPU(222);
			}
		}


		for (;;)
		{
			if (click)
			{
				if (!(scePowerIsBatteryCharging()))
					if (scePowerGetCpuClockFrequency() != 222)
						break;
			}
			else
			{
				if (scePowerIsBatteryCharging())
					if (scePowerGetCpuClockFrequency() != 333)
						break;
			}

			sceKernelDelayThread(DELAY_TIME);
		}
	}

	return sceKernelExitDeleteThread(0);
}

int module_start(SceSize args, void *argp)
{
	SceUID th = sceKernelCreateThread("1337acscwyacyp", main_thread, 8, 16*1024, 0, NULL);

	if (th >= 0)
		sceKernelStartThread(th, args, argp);

	return 0;
}

